﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=234238

namespace i8017HW_Basic_Info_Csharp.Pages
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class I8017HCW : Page
    {
        Int16 s17hc = -1;
        Int16 jp = 0;
        Int16 maxch = 0;
        Int16 ver = 0;
        Int16 gain=4;
        TextBox[] AI_txt;
        TextBox[] G_txt;
        TextBox[] O_txt;
        public I8017HCW()
        {
            this.InitializeComponent();
            AI_txt = new TextBox[8] { C0_txt, C0_txt, C2_txt, C3_txt, C4_txt, C5_txt, C6_txt, C7_txt };
            G_txt = new TextBox[8] { G0_txt, G0_txt, G2_txt, G3_txt, G4_txt, G5_txt, G6_txt, G7_txt };
            O_txt = new TextBox[8] { O0_txt, O0_txt, O2_txt, O3_txt, O4_txt, O5_txt, O6_txt, O7_txt };
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Int16 ch = 0;
            UInt16 gval=0;
            Int16 oval = 0;
            s17hc = (Int16)slot_cbx.SelectedIndex;
            if (pac8017HWNet.pac8017HW.Init(s17hc) == 0)
            {
                pac8017HWNet.pac8017HW.SingleEndJumper(s17hc, ref jp);
                if (jp == 0)
                {
                    maxch = 8;
                    Jumper_txt.Text = "Differential";
                }
                else
                {
                    maxch = 16;
                    Jumper_txt.Text = "Single Ended";
                }
                pac8017HWNet.pac8017HW.FirmwareVersion(s17hc, ref ver);
                FW_ver_txt.Text = String.Format("{0:X4}", ver);
                for (ch = 0; ch < 8; ++ch)
                {
                    pac8017HWNet.pac8017HW.Ch_mAGainOffset(s17hc, ch, ref gval,ref oval);
                    G_txt[ch].Text = gval.ToString();
                    O_txt[ch].Text = oval.ToString();
                }
                Float_Format_chk.IsChecked = true;
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
            }
        }

        private void Float_Format_chk_Click(object sender, RoutedEventArgs e)
        {
            if (Float_Format_chk.IsChecked.Value == true)
            {
                HEX_Format_chk.IsChecked = false;
            }
            else
            {
                HEX_Format_chk.IsChecked = true;
            }
        }

        private void HEX_Format_chk_Click(object sender, RoutedEventArgs e)
        {
            if (HEX_Format_chk.IsChecked.Value == true)
            {
                Float_Format_chk.IsChecked = false;
            }
            else
            {
                Float_Format_chk.IsChecked = true;
            }
        }

        private void Read_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 ch = 0;
            Int16 hval = 0;
            float fval = 0;
            for (ch = 0; ch < maxch; ++ch)
            {
                if (Float_Format_chk.IsChecked.Value == true)
                {
                    pac8017HWNet.pac8017HW.ReadAI(s17hc, ch, gain, ref fval);
                    AI_txt[ch].Text = String.Format("{0:00.000}", fval);
                }
                else
                {
                    pac8017HWNet.pac8017HW.ReadAIHex(s17hc, ch, gain, ref hval);
                    AI_txt[ch].Text = String.Format("{0:X4}", hval);
                }
            }
        }
    }
}
